/*
  Showing number 0-9 on a Common Anode 7-segment LED display
  Displays the numbers 0-9 on the display, with one second inbetween.
    A
   ---
F |   | B
  | G |
   ---
E |   | C
  |   |
   ---
    D
  This example code is in the public domain.
 */
#include "Wire.h"
#include "IRremote.h"
int receiver = 13;
int flag = 99;
long randNumber1, randNumber2;
long randNumber21, randNumber22;

/*--- Declarations ---*/
IRrecv irrecv(receiver);
decode_results results;

const int MPU_ADDR = 0x68;
int16_t accelerometer_x, accelerometer_y, accelerometer_z;
int16_t gyro_x=69, gyro_y=69, gyro_z=69;
int16_t temperature;

char tmp_str[7];

char* convert_int16_to_str(int16_t i) {
  sprintf(tmp_str, "%6d", i);
  return tmp_str;
}

int pinA = 6;
int pinB = 7;
int pinC = 8;
int pinD = 9;
int pinE = 10;
int pinF = 11;
int pinG = 12;
int D1 = 2;
int D2 = 3;
int D3 = 4;
int D4 = 5;


void translateIR() // takes action based on IR code received
{
  switch(results.value)
  {
  case 0xFF9867: Serial.println("0");flag=0;   break;
  case 0xFFA25D: Serial.println("1"); flag=1;   break;
  case 0xFF629D: Serial.println("2"); flag=2;   break;
  case 0xFFE21D: Serial.println("3"); flag=3;  break;
  case 0xFF22DD: Serial.println("4"); flag=4;   break;
  case 0xFF02FD: Serial.println("5"); flag=5;    break;
  case 0xFFC23D: Serial.println("6"); flag=6;   break;
  case 0xFFE01F: Serial.println("7"); flag=7;  break;
  case 0xFFA857: Serial.println("8"); flag=8;   break;
  case 0xFF906F: Serial.println("9"); flag=9;   break;
  case 0xFF18E7: Serial.println("^"); flag++; break;
  case 0xFF4AB5: Serial.println("v"); flag--; break;
  case 0xFFFFFFFF: Serial.println(" REPEAT");break;  

  default: 
    Serial.println(" other button   ");
  }// End Case
  delay(500); // Do not get immediate repeat
} //END translateIR


// the setup routine runs once when you press reset:
void setup() {                
  // initialize the digital pins as outputs.
  pinMode(pinA, OUTPUT);     
  pinMode(pinB, OUTPUT);     
  pinMode(pinC, OUTPUT);     
  pinMode(pinD, OUTPUT);     
  pinMode(pinE, OUTPUT);     
  pinMode(pinF, OUTPUT);     
  pinMode(pinG, OUTPUT);   
  pinMode(D1, OUTPUT);  
  pinMode(D2, OUTPUT);  
  pinMode(D3, OUTPUT);  
  pinMode(D4, OUTPUT); 
  Serial.begin(9600); 

  digitalWrite(D1, HIGH);
  digitalWrite(D2, HIGH);
  digitalWrite(D3, HIGH);
  digitalWrite(D4, HIGH);

  irrecv.enableIRIn(); // Start the receiver
  Wire.begin();
  Wire.beginTransmission(MPU_ADDR);
  Wire.write(0x6B);
  Wire.write(0);
  Wire.endTransmission(true);
  randomSeed(analogRead(A1));
  randNumber1 = random(10, flag);
  randNumber2 = random(10, flag);
  randNumber21 = random(10, flag);
  randNumber22 = random(10, flag);
}

void setDigit(int d){
  if(d==0){
  digitalWrite(pinA, LOW);   
  digitalWrite(pinB, LOW);   
  digitalWrite(pinC, LOW);   
  digitalWrite(pinD, LOW);   
  digitalWrite(pinE, LOW);   
  digitalWrite(pinF, LOW);   
  digitalWrite(pinG, HIGH); 
    }
  else if(d==1){
  digitalWrite(pinA, HIGH);   
  digitalWrite(pinB, LOW);   
  digitalWrite(pinC, LOW);   
  digitalWrite(pinD, HIGH);   
  digitalWrite(pinE, HIGH);   
  digitalWrite(pinF, HIGH);   
  digitalWrite(pinG, HIGH); 
    }
  else if(d==2){
  digitalWrite(pinA, LOW);   
  digitalWrite(pinB, LOW);   
  digitalWrite(pinC, HIGH);   
  digitalWrite(pinD, LOW);   
  digitalWrite(pinE, LOW);   
  digitalWrite(pinF, HIGH);   
  digitalWrite(pinG, LOW); 
    } 
  else if(d==3){
  digitalWrite(pinA, LOW);   
  digitalWrite(pinB, LOW);   
  digitalWrite(pinC, LOW);   
  digitalWrite(pinD, LOW);   
  digitalWrite(pinE, HIGH);   
  digitalWrite(pinF, HIGH);   
  digitalWrite(pinG, LOW); 
    } 
  else if(d==4){
  digitalWrite(pinA, HIGH);   
  digitalWrite(pinB, LOW);   
  digitalWrite(pinC, LOW);   
  digitalWrite(pinD, HIGH);   
  digitalWrite(pinE, HIGH);   
  digitalWrite(pinF, LOW);   
  digitalWrite(pinG, LOW); 
    } 
  else if(d==5){
  digitalWrite(pinA, LOW);   
  digitalWrite(pinB, HIGH);   
  digitalWrite(pinC, LOW);   
  digitalWrite(pinD, LOW);   
  digitalWrite(pinE, HIGH);   
  digitalWrite(pinF, LOW);   
  digitalWrite(pinG, LOW); 
    } 
  else if(d==6){
  digitalWrite(pinA, LOW);   
  digitalWrite(pinB, HIGH);   
  digitalWrite(pinC, LOW);   
  digitalWrite(pinD, LOW);   
  digitalWrite(pinE, LOW);   
  digitalWrite(pinF, LOW);   
  digitalWrite(pinG, LOW); 
    }  
  else if(d==7){
  digitalWrite(pinA, LOW);   
  digitalWrite(pinB, LOW);   
  digitalWrite(pinC, LOW);   
  digitalWrite(pinD, HIGH);   
  digitalWrite(pinE, HIGH);   
  digitalWrite(pinF, HIGH);   
  digitalWrite(pinG, HIGH); 
    } 
  else if(d==8){
  digitalWrite(pinA, LOW);   
  digitalWrite(pinB, LOW);   
  digitalWrite(pinC, LOW);   
  digitalWrite(pinD, LOW);   
  digitalWrite(pinE, LOW);   
  digitalWrite(pinF, LOW);   
  digitalWrite(pinG, LOW); 
    } 
  else if(d==9){
  digitalWrite(pinA, LOW);   
  digitalWrite(pinB, LOW);   
  digitalWrite(pinC, LOW);   
  digitalWrite(pinD, LOW);   
  digitalWrite(pinE, HIGH);   
  digitalWrite(pinF, LOW);   
  digitalWrite(pinG, LOW); 
    } 
  else if(d==10){
  digitalWrite(pinA, LOW);   
  digitalWrite(pinB, LOW);   
  digitalWrite(pinC, HIGH);   
  digitalWrite(pinD, HIGH);   
  digitalWrite(pinE, LOW);   
  digitalWrite(pinF, LOW);   
  digitalWrite(pinG, LOW); 
  }
}

// the loop routine runs over and over again forever:
void loop() {
  if(irrecv.decode(&results))
  {
    translateIR();
    irrecv.resume();
  }

  setDigit(flag);
  digitalWrite(D1, LOW);
  digitalWrite(D2, HIGH);
  digitalWrite(D3, HIGH);
  digitalWrite(D4, HIGH);
  delay(12);

  //new code
  Wire.beginTransmission(MPU_ADDR);
  Wire.write(0x3B);
  Wire.endTransmission(false);
  Wire.requestFrom(MPU_ADDR, 6*2, true);
  accelerometer_x = Wire.read()<<8|Wire.read();
  accelerometer_y = Wire.read()<<8|Wire.read();
  accelerometer_z = Wire.read()<<8|Wire.read();
  temperature = Wire.read()<<8|Wire.read();
  gyro_x = Wire.read()<<8|Wire.read();
  gyro_y = Wire.read()<<8|Wire.read();
  gyro_z = Wire.read()<<8|Wire.read();

 
  
//  Serial.print("gX = "); Serial.print(gyro_x);
//  Serial.print(" | gY = "); Serial.print(gyro_y);
//  Serial.print(" | gZ = "); Serial.print(gyro_z);
//  Serial.println();
//
//  Serial.print("aX = "); Serial.print(accelerometer_x);
//  Serial.print(" | aY = "); Serial.print(accelerometer_y);
//  Serial.print(" | aZ = "); Serial.print(accelerometer_z);
//  Serial.println();



  if(gyro_z<=-1000||gyro_z>=1000||gyro_y<=-1000||gyro_y>=1000||gyro_x<=-1000||gyro_x>=1000){
    randNumber1 = random(1,flag);
    randNumber2 = random(1,flag);
  }
  delay(1);
   if(gyro_z<=-1000||gyro_z>=1000||gyro_y<=-1000||gyro_y>=1000||gyro_x<=-1000||gyro_x>=1000){
    randNumber21 = random(1,flag);
    randNumber22 = random(1,flag);
  }
  delay(1);

  //choosing winner 
  if(randNumber1 == randNumber2 && randNumber21 == randNumber22){
    if (randNumber1 == randNumber21){
      Serial.println("Draw !");
    }
    else if (randNumber1 == 1 && randNumber21 != 1){
      Serial.println("Winner - P1");
    }
    else if (randNumber1 != 1 && randNumber21 == 1){
      Serial.println("Winner - P2");
    }
    else{
      if(randNumber1 > randNumber21){
        Serial.println("Winner - P1");
      }
      else{
        Serial.println("winner - P2");
      }
    }
  }
  else if (randNumber1 == randNumber2 && randNumber21 != randNumber22){
    Serial.println("Winner - P1");
  }
  else if (randNumber1 != randNumber2 && randNumber21 == randNumber22){
    Serial.println("Winner - P2");
  }
  else if (randNumber1 != randNumber2 && randNumber21 != randNumber22){
    if(randNumber1 + randNumber2 > randNumber21 + randNumber22){
      Serial.println("Winner - P1");
    }
    else if(randNumber1 + randNumber2 < randNumber21 + randNumber22){
      Serial.println("Winner - P2");
    }
    else{
      Serial.println("Draw");
    }
  }
  
  setDigit(randNumber1);
  digitalWrite(D1, HIGH);
  digitalWrite(D2, HIGH);
  digitalWrite(D3, LOW);
  digitalWrite(D4, HIGH);
  delay(12);

  setDigit(randNumber2);
  digitalWrite(D1, HIGH);
  digitalWrite(D2, HIGH);
  digitalWrite(D3, HIGH);
  digitalWrite(D4, LOW);
  delay(12);
  
}

